package sample.app;

// import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
// import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
// import java.io.File;
import java.lang.reflect.Method;
// import java.util.ArrayList;
import java.util.Arrays;
import java.util.Hashtable;
import java.util.List;
import javax.swing.AbstractButton;
import javax.swing.Box;
// import javax.swing.JCheckBox;
// import javax.swing.JComboBox;
import javax.swing.JMenu;
// import javax.swing.JPanel;

import misc.ApplicationManager;
// import misc.Bundle;
// import misc.Config;
import misc.Util;

import sample.gui.JSample;
import sample.model.Sample;

public class SampleManager implements ApplicationManager, ActionListener {

    // ========================================
    private JSample jSample;

    // ========================================
    public static final String actionEmpty              = "Empty";

    public static final String actionMyAction           = "MyAction";
    
    // ========================================
    public static final List<String> fileActionsNames =
				Arrays.asList (actionEmpty);
    public static final List<String> sampleActionsNames =
				Arrays.asList (actionMyAction);

    // ========================================
    @SuppressWarnings ("unchecked")
				public static final Hashtable<String, Method> actionsMethod =
				Util.collectMethod (SampleManager.class, fileActionsNames, sampleActionsNames);

    public void  actionPerformed (ActionEvent e) {
				Util.actionPerformed (actionsMethod, e, this);
    }

    // ========================================
    Sample sample;

    // ========================================
    public SampleManager (Sample sample, JSample jSample) { //, JSampleDialog jSampleDialog) {
				this.sample= sample;
				this.jSample = jSample;
				// this.jSampleDialog = jSampleDialog;
    }

    // ========================================
    public void addMenuItem (JMenu... jMenu) {
				int idx = 0;
				Util.addMenuItem (fileActionsNames, jMenu[idx++], this);
				Util.addMenuItem (sampleActionsNames, jMenu[idx++], this);
    }

    // ========================================
    public void addIconButtons (Container container, Dimension space) {
				Util.addIconButton (fileActionsNames, container, this);
				container.add (Box.createRigidArea (space));
				Util.addIconButton (sampleActionsNames, container, this);
    }

    // ========================================
    public void addActiveButtons (Hashtable<String, AbstractButton> buttons) {
				// ressence les boutons à griser
    }

    // ========================================
    public void actionEmpty () {
				sample.reset ();
    }

    // ========================================
    public void actionMyAction () {
				sample.addData ();
    }

    // ========================================
}
