package sample.gui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingConstants;
import javax.swing.border.Border;
import javax.swing.border.EtchedBorder;

@SuppressWarnings ("serial") public class JData extends JPanel {

		// ======================================================================
		public static final int width = 100;
		public static final int height = 55;
		public static final Font letterFont = new Font ("Serif", Font.BOLD, 18);

		// ======================================================================
		public JData (final JSample jSample, final String data, final boolean template) {
				super (new BorderLayout ());
				Border border = BorderFactory.createEtchedBorder (EtchedBorder.LOWERED);
				setBorder (border);
				setPreferredSize (new Dimension (width, height));
				JLabel jAlpha = new JLabel (data, SwingConstants.CENTER);
				jAlpha.setFont (letterFont);
				add (jAlpha, BorderLayout.CENTER);

				addMouseListener (new MouseAdapter () {
								public void mousePressed (MouseEvent e) {
										JData jData = JData.this;
										if (template)
												jData = new JData (jSample, data, false);
										else
												JData.this.getParent ().remove (jData);
										jSample.startDragJData (jData, e);
								}
								public void mouseReleased (MouseEvent e) {
										jSample.stopDragJData ();
								}
						});
				addMouseMotionListener (new MouseAdapter () {
								public void mouseDragged (MouseEvent e) {
										jSample.dragJData ();
								}
						});
		}

    // ========================================
}
